/*

So fun story:
I made the SpawnCompanionsCiriDash .ws file, and had that working nicely, except one problem
It caused the game to crash! After 3 or so dash's through some enemies, the game would crash, complain
about some kind of memory access error and 0x00000080, or 0x0000009f or something similar.

So I thought, maybe I've f'ed up, maybe the latent functions don't work well with animations and effects and what nothing
So I moved it all into here. I create my own state machine kind of thing.
And it worked well. The player class added a timer, with an update frequeny of 0.015,  (so about 60 times a second)
This timer then calls the 'Update' function in the follow class.
The idea was, that each method call would be quick, and sleeping would just consist of counting down a floating point number to 0.

And yeah, it worked, she dashed through enemies and what not. Sweet.
But
Alas. The game f'ing crashed again. And again. and again. And ermagherd this is frustrating

So I removed absolutely everything, stripped it down to bare bones, and then ran it.
No crash.

So I slowly added more things, until eventually, I realised the problematic statement.
ONE LINE OF CODE

//action.SetForceExplosionDismemberment();

This little f'ker will spontaneously crash the game, for whatever stupid reason.
Looking at the error log, it seems to crash during rendering. It's trying to access some memory location outside of the allocated bounds
The explosion dismemberment must be causing it to render something dodgey, and thus crash.

Why doesn't this occur with normal ciri gameplay? I dunno. The game goes into slow-mo when you dash through enemies.
Maybe the extra time gets rid of this bug? Or maybe it's just my computer? Who knows.

Either way, I'm leaving this here, in case I ever need it again.

*/
class SCMCombat
{
	var npc : CNewNPC;
	var animComp : CMovingPhysicalAgentComponent;
	
	private var sleepTime : float;
	default sleepTime = 0;

	public function Sleep(time : float)
	{
		sleepTime += time;
	}
	
	function PlayAnim(nam : name)
	{
		if(animComp) animComp.PlaySlotAnimationAsync(nam, 'NPC_ANIM_SLOT');
	}


	
	public function Init(npc : CNewNPC)
	{
		this.npc = npc;
		this.animComp = (CMovingPhysicalAgentComponent)npc.GetComponentByClassName('CMovingPhysicalAgentComponent');
	}	
	
	public function Start()
	{
		sleepTime = 0;
	}
	
	public function Stop()
	{
	
	}
	
	public final function Update(dt : float) : bool
	{
		if(sleepTime > 0)
		{
			sleepTime -= dt;
			if(sleepTime < 0)
			{
				dt = -sleepTime;
				sleepTime = 0;
				return DoUpdate(dt);
			}
			else
			{
				return DoSleepUpdate(dt);
			}
		}
		else
		{
			return DoUpdate(dt);
		}
	}
	
	function DoSleepUpdate(dt : float) : bool
	{
		return false;
	}
	
	function DoUpdate(dt : float) : bool
	{
		return true;
	}
	
	
	function log(str : string)
	{
		LogChannel('ModSpawnCompanions', "====================" + str + "====================");
	}

}

class SCMCiriCombat
{
	
}

class SCMCiriDashCombat extends SCMCombat
{
	private const var STAGE_POSE : int; default STAGE_POSE = 0;
	private const var STAGE_DISAPPEAR : int; default STAGE_DISAPPEAR = 1;
	private const var STAGE_PREPARE_AND_STRIKE : int; default STAGE_PREPARE_AND_STRIKE = 2;
	private const var STAGE_STRIKING : int; default STAGE_STRIKING = 3;
	
	private var stage : int;	default stage = 0;
		
	private var bloodExplode : CEntityTemplate;

	public function Init(npc : CNewNPC)
	{
		super.Init(npc);
		
		if ( !bloodExplode )
			bloodExplode = (CEntityTemplate)LoadResource('blood_explode');
	}
	
	public function Start()
	{
		super.Start();
		
		reset();
		stage = 0;
	}
	
	public function Stop()
	{
		super.Stop();
		
		reset();
		
		
		npc.PlayEffect('appear_cutscene');
		npc.PlayEffect('appear');
	}
	
	function reset()
	{
		stage = -1;
		targets.Clear();
		slideTarget = NULL;
	}
	
	private var targets : array<CActor>;
	

	function DoSleepUpdate(dt : float) : bool
	{
		if(stage == STAGE_STRIKING)
		{
			_updateStrikeVictims();
		}
		
		return false;
	}
	
	private function _updateStrikeVictims()
	{
		var pos : Vector;
		var actor : CActor;
		var i : int;
		var distance : float;
		pos = npc.GetWorldPosition();
		
		log("Update Strike Victims");
		
		for(i = targets.Size()-1; i >= 0; i-=1)
		{
			actor = targets[i];
			if(actor && actor.IsAlive())
			{
				distance = VecDistanceSquared(actor.GetWorldPosition(), pos);
				if(distance < 1)
				{
					OnCollide(targets[i]);
					targets.Erase(i);
				}
			}
		}
	}
	
	
	function DoUpdate(dt : float) : bool
	{
		switch(stage)
		{
		case STAGE_POSE: return DO_STAGE_POSE(dt);
		case STAGE_DISAPPEAR: return DO_STAGE_DISAPPEAR(dt);
		case STAGE_PREPARE_AND_STRIKE: return DO_STAGE_PREPARE_AND_STRIKE(dt);
		case STAGE_STRIKING: return DO_STAGE_STRIKING(dt);
		}
		
		return true;
	}
	
	var slideTarget : CActor;
	var dashCount : int;
	
	private function DO_STAGE_POSE(dt : float) : bool
	{
		slideTarget = GetFinalPositionActor();
		
		if(slideTarget)
		{
			//First stage, pose Ciri, and sleep
			PlayAnim('woman_ciri_sword_special_heavy_attack_charge_start_lp');
			npc.PlayEffect('disappear');
			RotateToNewHeading(0.5, VecNormalize(slideTarget.GetWorldPosition() - npc.GetWorldPosition()));
			
			Sleep(0.5);
			stage = STAGE_DISAPPEAR;
			
			dashCount = 30;//Clamp(RandRange(targets.Size()/3+1, 1) + targets.Size()/10, 1, 4);
			
			return false;
		}
		return true;
	}
	
	private function DO_STAGE_DISAPPEAR(dt : float) : bool
	{
		
		slideTarget = GetFinalPositionActor();
		
		if(!slideTarget)
		{
			//Theres nothing to attack, cancel
			return true;
		}
	
	
		if(dashCount > 0)
		{
			dashCount -= 1;
		
			npc.PlayEffect('disappear_cutscene');
			Sleep(0.8);
			stage = STAGE_PREPARE_AND_STRIKE;
			
			return false;
		}
		
		return true;
	}
	
	private function DO_STAGE_PREPARE_AND_STRIKE(dt : float) : bool
	{
		var newHeadingVec		: Vector;
		var destinationPos		: Vector;
		var distance			: float;
		var angleToTarget		: float;
		var vecDistance			: float;
		var slideDuration		: float;
		var i : int;
	
	
		if(slideTarget)
		{
			npc.PlayEffect('disappear');
			npc.PlayEffect('appear_cutscene');
			
			angleToTarget = NodeToNodeAngleDistance( slideTarget, npc );
			
			newHeadingVec = VecFromHeading( AngleNormalize180( npc.GetHeading() - angleToTarget ) );
		
			vecDistance = VecDistance(npc.GetWorldPosition(), slideTarget.GetWorldPosition());
			distance = ClampF(2.0f, HOLD_SPECIAL_ATTACK_BUTTON_TIME, 2.0f);
			distance = SPECIAL_ATTACK_HEAVY_MAX_DIST * (distance * 0.25);
			distance = ClampF(distance, vecDistance + distance, SPECIAL_ATTACK_HEAVY_MAX_DIST);

			
			destinationPos = npc.GetWorldPosition() + newHeadingVec*distance;
			
			slideDuration = distance/30; 
			slideDuration = ClampF(slideDuration,0.1,0.4);
			
			SlideToNewPosition(slideDuration, destinationPos, newHeadingVec);
			
			Sleep(slideDuration);
			stage = STAGE_STRIKING;
			
			return false;
		}
		return true;
	}
	
	private function DO_STAGE_STRIKING(dt : float) : bool
	{
		if(dashCount > 0)
		{
			stage = STAGE_DISAPPEAR;
			Sleep(0.2);
		}
		else
		{
			npc.StopEffect('fury');
			npc.PlayEffect('appear_cutscene');
			//PlayAnim('woman_ciri_sword_special_heavy_attack_long_end');
			Sleep(0.8);
			stage = -1;
		}
		
		return false;
	}
	
	private const var HOLD_SPECIAL_ATTACK_BUTTON_TIME	: float;	default HOLD_SPECIAL_ATTACK_BUTTON_TIME = 0.2f;
	private const var SPECIAL_ATTACK_HEAVY_MAX_DIST		: float;	default SPECIAL_ATTACK_HEAVY_MAX_DIST	= 15.0f;
	
	
	
	
	
	
	function OnCollide(collidedActor : CActor)
	{
		var action 				: W3Action_Attack;
		var bloodEntity			: CEntity;
		var position			: Vector;
	
		if ( collidedActor == npc || !collidedActor.IsAlive() || GetAttitudeBetween( npc, collidedActor ) != AIA_Hostile )
			return ;
		
		if ( collidedActor )
		{
			action = new W3Action_Attack in thePlayer;
			//(CGameplayEntity)
			action.Init(npc,collidedActor,NULL,npc.GetInventory().GetItemFromSlot( 'r_weapon' ),'attack_heavy',npc.GetName(),EHRT_Heavy, false, false, 'attack_heavy', AST_Jab, ASD_NotSet, true, false, false, false );
			
			action.SetCriticalHit();
			//action.SetForceExplosionDismemberment();
			action.AddEffectInfo(EET_Knockdown);
			//action.SetProcessBuffsIfNoDamage(true);
			
			theGame.damageMgr.ProcessAction( action );
			
			delete action;	
			
			position = collidedActor.GetWorldPosition();
			position.Z += 0.7;
			bloodEntity = theGame.CreateEntity(bloodExplode,position);
			bloodEntity.PlayEffect('blood_explode');
			bloodEntity.DestroyAfter(5.0);
		}
	}
			
	private function SlideToNewPosition ( duration : float, newPos : Vector, optional newHeading : Vector, optional alsoTeleport : bool  )
	{
		var movementAdjustor	: CMovementAdjustor;
		var ticket 				: SMovementAdjustmentRequestTicket;
		
		movementAdjustor = npc.GetMovingAgentComponent().GetMovementAdjustor();
		movementAdjustor.CancelAll();
		
		ticket = movementAdjustor.CreateNewRequest( 'CiriSpecialAttackSlide' );
		movementAdjustor.MaxRotationAdjustmentSpeed(ticket, 1000000.f);
		movementAdjustor.AdjustmentDuration(ticket, duration);
		movementAdjustor.SlideTo(ticket, newPos);
		
		log("Slide to go X:" + newHeading.X + ", Y:" + newHeading.Y + ", Z:" + newHeading.Z);
		
		//if ( newHeading != Vector(0,0,0) )
			//movementAdjustor.RotateTo(ticket,VecHeading(newHeading));
	}
	
	private function GetFinalPositionActor() : CActor
	{
		var i : int;
		var dotProd : float;
		var bestDotProd : float;
		var bestActor : CActor;
		var bestHeading : Vector;
		var myPos : Vector;
		
		targets.Clear();
		targets = npc.GetNPCsAndPlayersInRange(12, 30, '', FLAG_Attitude_Hostile + FLAG_OnlyAliveActors);
		
		log("Found " + targets.Size() + " targets");
		
		if(targets.Size() == 0) return bestActor;
		
		
		myPos = npc.GetWorldPosition();
		
		for ( i = targets.Size()-1 ; i >= 0 ; i-=1 )
		{
			if ( !targets[i].GetGameplayVisibility() )
			{
				targets.Erase(i);
			}
			else
			{
				bestHeading += targets[i].GetWorldPosition();//(targets[i].GetWorldPosition() - myPos);
			}
		}
		//Average NPC position
		bestHeading /= Vector(targets.Size(), targets.Size(), targets.Size());
		bestHeading = (bestHeading - myPos);
		bestHeading = VecNormalize(bestHeading);
		bestDotProd = 0;
		
		log("Best Heading: " + bestHeading.X + "," + bestHeading.Y + "," + bestHeading.Z);
		
		for ( i = targets.Size()-1 ; i >= 0 ; i-=1 )
		{
			//Gets the angle between the heading vector, and the entity
			dotProd = VecDot2D(VecNormalize((targets[i].GetWorldPosition() - myPos)), bestHeading);
			if(dotProd < 0) dotProd = -dotProd;
			
			log("Dotprod: " + dotProd);
			if(dotProd > bestDotProd)
			{
				bestActor = targets[i];
				bestDotProd = dotProd;
			}
		}
		
		return bestActor;
	}
	
	private function RotateToNewHeading ( duration : float, newHeading : Vector  )
	{
		var movementAdjustor	: CMovementAdjustor;
		var ticket 				: SMovementAdjustmentRequestTicket;
		
		
		movementAdjustor = npc.GetMovingAgentComponent().GetMovementAdjustor();
		movementAdjustor.CancelAll();
		ticket = movementAdjustor.CreateNewRequest( 'CiriDodgeRotation' );
		movementAdjustor.MaxRotationAdjustmentSpeed(ticket, 1000000.f);
		movementAdjustor.AdjustmentDuration(ticket, duration);
		if ( newHeading != Vector(0,0,0) )
			movementAdjustor.RotateTo(ticket,VecHeading(newHeading));
		
	}
	
	
	
	
	
	
}